% LOADCACHEDDATASET     Loads cached feature vectors and labels.
% Stephen Gould <sgould@stanford.edu>
%

function [x, y, w] = loadCachedDataset(filename);

fid = fopen(filename, 'r');
versionFlags = fread(fid, 1, 'int32');
nFeatures = fread(fid, 1, 'int32');

fseek(fid, 0, 'eof');
nSamples = (ftell(fid) - 8) / (8 * nFeatures + 12);
fseek(fid, 8, 'bof');

disp(['reading ', int2str(nSamples), ' samples of length ', int2str(nFeatures)]);

x = zeros(nSamples, nFeatures);
y = int32(zeros(nSamples, 1));
w = zeros(nSamples, 1);

for i = 1:nSamples,
    y(i) = fread(fid, 1, 'int32');
    x(i, :) = fread(fid, nFeatures, 'float64');
    w(i) = fread(fid, 1, 'float64');
end;

fclose(fid);