% CREATE LAYER LABELS
%

DATADIR = '/afs/cs/u/sgould/scratch/scene/msrc/data/';
LBLDIR = [DATADIR, 'labels/'];

images = dir([LBLDIR, '*.regions.txt']);
images = {images(:).name};
%images = {images{randperm(length(images))}};

% zero-based labels
NAMES = {'building', 'grass', 'tree', 'cow', 'sheep', 'sky', 'airplane', 'water', ...
    'face', 'car', 'bicycle', 'flower', 'sign', 'bird', 'book', 'chair', 'road', ...
    'cat', 'dog', 'body', 'boat'};

MAPPING = repmat(-1, 21, 1);
%MAPPING(4) = 7; % cow
%MAPPING(5) = 9; % sheep
MAPPING = 0:20;

for i = 1:length(images),
    baseName = images{i}(1:end - 12);    
    disp(baseName);
    
    regions = load([LBLDIR, baseName, '.regions.txt']);
    origLayers = load([LBLDIR, baseName, '.regions.txt']);
    origLayers = origLayers - min(origLayers(:));

    numOrigLayers = max(origLayers(:)) + 1;
    layers = zeros(size(origLayers));
    numLayers = 0;
    for k = 1:numOrigLayers,
        [L, N] = bwlabel(origLayers == k - 1);
        for n = 1:N,
            layers(L == n) = numLayers;
            numLayers = numLayers + 1;
        end;
    end;
    disp(['layers: ', int2str(numLayers)]);
    
    layerLabels = int32(repmat(-1, numLayers, 1));
    for k = 1:numLayers,
        lbl = mode(regions(layers == k - 1));
        if (lbl >= 0) && (MAPPING(lbl + 1) > -1),
            layerLabels(k) = MAPPING(lbl + 1);
        end;
    end;

    dlmwrite([LBLDIR, baseName, '.layers.txt'], layers, 'delimiter', ' ');
    dlmwrite([LBLDIR, baseName, '.layerLabels.txt'], layerLabels, 'delimiter', ' ');
end; 