% MSRC21TOBACKGROUND    Converts MSRC 21-class labels to 8-class background labels
% Stephen Gould <sgould@stanford.edu>
%

LBLDIR = '/afs/cs.stanford.edu/u/sgould/scratch2/msrc/data/labels/';

% void, building, grass, tree, cow, sheep, sky, airplane, water, face, car,
% bicycle, flower, sign, bird, book, chair, road, cat, dog, body, boat
MAPPING = [-1, 5, 3, 1, 6, 6, 0, 6, 4, 6, 6, 6, 6, 5, 6, 6, 6, 2, 6, 6, 6, 6];

files = dir([LBLDIR, '*.21.regions.txt']);
files = {files(:).name};

for i = 1:length(files),
    baseName = files{i}(1:end - 15);
    
    disp(baseName);
    labels = load([LBLDIR, baseName, '.21.regions.txt']);
    labels = MAPPING(labels + 2);
    
    % imagesc(labels, [-1, 7]); drawnow; pause(0.1);
    dlmwrite([LBLDIR, baseName, '.bg.regions.txt'], labels, ' ');    
end;
