#!/bin/csh
# TRAIN BOOSTED PIXEL CLASSIFIERS
# Stephen Gould <sgould@stanford.edu>
#

set BASEDIR = "/afs/cs/u/tianshig/SVL/stanford/sceneUnderstand/experiment/"
cd ${BASEDIR}

set FLAGS = "NOQSUB"

if ((`hostname` == "ai.Stanford.EDU") || (`hostname` == "robo.Stanford.EDU")) then
    set FLAGS = "-q quicksail"
    #set FLAGS = "-l arch=x86_64"
endif

set BINDIR = "/afs/cs/u/tianshig/SVL/bin"

set TRAINLIST = "${BASEDIR}/trainList.txt"
set EVALLIST = "${BASEDIR}/evalList.txt"

# regions
if (1) then
    set CONFIG = "${BASEDIR}/defaultConfig.xml"

    set SUBSAMPLE = 250
    set ROUNDS = 500
    set SPLITS = 2

    set OPTIONS = "-subSample $SUBSAMPLE -rounds $ROUNDS -splits $SPLITS"
    set OPTIONS = "-set svlML.svlBoostedClassifier boostMethod DISCRETE ${OPTIONS}"
    set OPTIONS = "-verbose -profile ${OPTIONS}"

    foreach i (`seq 0 7`)
        set SCRIPT = "scripts/__trainBoostedClass${i}.sh"
        set CMD = "$BINDIR/sceneLearnPixelClassifiers -config $CONFIG $OPTIONS -classId ${i} $TRAINLIST"
        echo $CMD

        if ("$FLAGS" == "NOQSUB") then
            $CMD
        else
            echo 'cd $PBS_O_WORKDIR' > $SCRIPT
            echo "${CMD}" >>  $SCRIPT

            waitforQs.sh 10
            qsub $FLAGS $SCRIPT
        endif
    end
endif
